
/**
 * Logger
 * @typedef {Object} Logger
 * @property {function(string):undefined} info - log info level
 * @property {function(string):undefined} warn - log warn level
 */

/**
 * getContextFn
 * @typedef {function(string, Object, Logger): Promise<*>} getContextFn
 */

/**
 * Resolver
 * @typedef {Object} Resolver
 * @property {function(string, getContextFn, Logger):Promise<string>} resolve - resolution function, gets: variable, getContextFn, and logger
 */

/**
 * Resolution
 * @typedef {Object} Resolution
 * @property {number} index - index
 * @property {string} key - key
 * @property {boolean} resolved - resolved
 * @property {string} value - value
 */

/**
 * PathResolution
 * @typedef {Object} PathResolution
 * @property {string} path - path
 * @property {Resolution} resolution - resolution
 */

/**
 * VariableResolver
 * @typedef {Object} VariableResolver
 * @property {function(string, { log?: Logger }): Promise<Resolution[]>} resolve - resolve a string variable
 * @property {function(Object, { log?: Logger }): Promise<PathResolution[]>} recursive - recursively resolve secrets on an object
 */
